<?php
//
// VPNKI connections remover script. Version 1.1. 
// Remove pptp-linux, xl2tpd, strongswan, openvpn. Tested on Raspberry Wheezy
// 20-01-2019
//
ini_set("log_errors", 1);
ini_set("error_log", "/var/log/vpnki_install.log");
error_log( "### Start VPNKI REMOVE ###" );

// Color class
	class Colors {
		private $foreground_colors = array();
		private $background_colors = array();

		public function __construct() {
			// Set up shell colors
			$this->foreground_colors['black'] = '0;30';
			$this->foreground_colors['dark_gray'] = '1;30';
			$this->foreground_colors['blue'] = '0;34';
			$this->foreground_colors['light_blue'] = '1;34';
			$this->foreground_colors['green'] = '0;32';
			$this->foreground_colors['light_green'] = '1;32';
			$this->foreground_colors['cyan'] = '0;36';
			$this->foreground_colors['light_cyan'] = '1;36';
			$this->foreground_colors['red'] = '0;31';
			$this->foreground_colors['light_red'] = '1;31';
			$this->foreground_colors['purple'] = '0;35';
			$this->foreground_colors['light_purple'] = '1;35';
			$this->foreground_colors['brown'] = '0;33';
			$this->foreground_colors['yellow'] = '1;33';
			$this->foreground_colors['light_gray'] = '0;37';
			$this->foreground_colors['white'] = '1;37';

			$this->background_colors['black'] = '40';
			$this->background_colors['red'] = '41';
			$this->background_colors['green'] = '42';
			$this->background_colors['yellow'] = '43';
			$this->background_colors['blue'] = '44';
			$this->background_colors['magenta'] = '45';
			$this->background_colors['cyan'] = '46';
			$this->background_colors['light_gray'] = '47';
		}

		// Returns colored string
		public function getColoredString($string, $foreground_color = null, $background_color = null) {
			$colored_string = "";

			// Check if given foreground color found
			if (isset($this->foreground_colors[$foreground_color])) {
				$colored_string .= "\033[" . $this->foreground_colors[$foreground_color] . "m";
			}
			// Check if given background color found
			if (isset($this->background_colors[$background_color])) {
				$colored_string .= "\033[" . $this->background_colors[$background_color] . "m";
			}

			// Add string and end coloring
			$colored_string .=  $string . "\033[0m";

			return $colored_string;
		}

		// Returns all foreground color names
		public function getForegroundColors() {
			return array_keys($this->foreground_colors);
		}

		// Returns all background color names
		public function getBackgroundColors() {
			return array_keys($this->background_colors);
		}
	}


$colors = new Colors();

echo "\n";
echo $colors->getColoredString("===============================================", "cyan") . "\n";
echo $colors->getColoredString("   Welcome to vpnki connection remover!", "cyan") . "\n";
echo $colors->getColoredString("===============================================", "cyan") . "\n\n";
echo "   This script remove:\n\n";
echo "   - pptp-linux package for PPTP connection\n";
echo "   - xl2tpd package for L2TP connection\n";
echo "   - strongswan package for IPsec connection\n";
echo "   - openvpn package for OpenVPN connection.\n\n";

// -----------------------------------------------------------
// Start remove packages pptp-linux xl2tpd strongswan openvpn
// -----------------------------------------------------------
echo "\n";
echo $colors->getColoredString("   1. Remove packages...", "cyan") . "\n";
echo "   Start to remove  pptp-linux xl2tpd strongswan openvpn...\n";
$remove=shell_exec('apt-get remove -y pptp-linux xl2tpd strongswan openvpn');
//echo $remove;
echo "   Packages are removed\n\n";

echo $colors->getColoredString("   2. Remove conf files...", "cyan") . "\n";

echo "   Remove /etc/ppp/peers/vpnki... ";
$remove=shell_exec('rm /etc/ppp/peers/vpnki');
echo "done\n\n";

echo "   Remove /etc/ppp/ip-up.d/routeadd... ";
$remove=shell_exec('rm /etc/ppp/ip-up.d/routeadd');
echo "done\n\n";

echo "   Remove lines from /etc/ppp/chap-secrets...";
$search = "# added by pptpsetup for vpnki";
$lines=file('/etc/ppp/chap-secrets');
$line_number = false;

while (list($key, $line) = each($lines) and !$line_number) {
   $line_number = (strpos($line, $search) !== FALSE) ? $key + 1 : $line_number;
}

echo $line_number;
$lineToDelete1 = $line_number-1;
$lineToDelete2 = $line_number;
unset($lines["$lineToDelete1"]);
unset($lines["$lineToDelete2"]);

if (!$fp = fopen('/etc/ppp/chap-secrets', 'w+'))
    {
        print "Cannot open file ($fileName)";
        }

  if($fp)
    {
        // write the array to the file
        foreach($lines as $ln) { fwrite($fp,$ln); }

        // close the file
        fclose($fp);
        }

echo "done";

echo "   Remove /etc/xl2tpd/xl2tpd.conf... ";
$remove=shell_exec('rm /etc/xl2tpd/xl2tpd.conf');
echo "done\n\n";

echo "   Remove /etc/ppp/options.l2tpd.client... ";
$remove=shell_exec('rm /etc/ppp/options.l2tpd.client');
echo "done\n\n";

//echo "   Lets remove /var/run/xl2tpd/l2tp-control... ";
//$remove=shell_exec('rm /var/run/xl2tpd/l2tp-control');
//echo "done\n\n";

echo "   Remove /etc/ipsec.secrets... ";
$remove=shell_exec('rm /etc/ipsec.secrets');
echo "done\n\n";

echo "   Remove /etc/ipsec.conf... ";
$remove=shell_exec('rm /etc/ipsec.conf');
echo "done\n\n";

echo "   Remove openvpn...";
$remove=shell_exec('rm -rf /etc/openvpn/');
echo "done\n\n";
error_log( "Packages and VPNKI connections removed successfully" );

echo "\n";
echo $colors->getColoredString("===============================================", "cyan") . "\n";
echo $colors->getColoredString("   Congrats! vpnki removed!", "cyan") . "\n";
echo $colors->getColoredString("===============================================", "cyan") . "\n\n";

error_log( "### Stop VPNKI REMOVE ###".PHP_EOL );
exit;
?>
